#ifndef __VT_H__
#define __VT_H__

#include "FastFit.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"
#include "Burden.h"
#include "Constant.h"
#include "math.h"
#include "MathStats.h"
#include <string>
#include <cstring>
#include <iostream>
#include <stdlib.h>
#include <algorithm>
#include <time.h>
#include "Random.h"
#include "My_mvt.h"
#include "GroupFromAnnotation.h"

class VT
{
    public:
        VT();
        ~VT();
        static bool vcfAnnotated;
	
	static bool preProcess;
	static int chop;
	static String chopTo;
	static int permuteMin;
	static int permuteMax;
	static bool noStep;
	static bool asymptotic;
	static bool permuteBool;
	static bool VTwtMB;
	static bool VTwtCMC_binary;
	static bool VTwtCMC_counts;

        //this is the total number of genes
        int geneCount;
	double markerMaf;
Vector mafIncluded,unique_maf;
	StringIntHash  geneHash;
	StringArray geneChrom;
	std::vector<int> start,end;
	Matrix genotypeMatrix,tmpGenoMatrix;

	Vector residuals_original,beta_hat,fixedEff;
	double sigma2_hat;
int length;

	VcfFileReader reader;
	VcfHeader header;
	VcfRecord record;

	void GetAllGenenamesVCF(String & chromName);
	void HashInGenes(std::string & gene);
	void ChopAndWrite(Pedigree & ped);

	//void PermuteTrait(Pedigree & ped, FastTransform & trans,int traitNum,int permutations);

	int VTPermuteAll(Pedigree & ped, FastTransform & trans, FastFit & engine,FILE * VTout, String & traitName);

	int VTPermuteFile(Pedigree & ped, FastTransform & trans, FastFit & engine,FILE * VTout,StringArray & genes,String & traitName);

bool GetTmpGenoMatrixDosage(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
bool GetTmpGenoMatrixVCF(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
bool GetTmpGenoMatrixPED(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
bool GetGenotypeMatrix(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
bool FinalizeGenoMatrix(FastTransform & trans,bool reduceDimension);
	void CalculatePermute(Pedigree & ped, FastTransform & trans,FastFit & engine,String & traitName);
	void CalculateAsymptotic(Pedigree & ped, FastTransform & trans,FastFit & engine,String & traitName);
	void Run(Pedigree & ped, FastTransform & trans, FastFit & engine,String & traitName);	
	void Run(Pedigree & ped);	

	double CalculatePvalue(Vector & score,Matrix & cov,double t_max);
	Vector GetConditionalDist(Vector & score,Matrix & cov,Vector & comb);
};

#endif
